<?php

namespace Quivers\Integration\Block\Checkout;

use Magento\Checkout\Block\Checkout\LayoutProcessor as MageLayoutProcessor;
use Quivers\Integration\LogTracking;

class LayoutProcessor
{

    const XML_ENABLED = 'quivers/parameters/active';

    public function afterProcess(MageLayoutProcessor $subject, $jsLayout)
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $scope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        
        $storeId = $storeManager->getStore()->getStoreId();
        $websiteId = $storeManager->getWebsite()->getWebsiteId();
        $scopeConfig = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Framework\App\Config\ScopeConfigInterface::class);
        $scopeId = $storeId ? $storeId : $websiteId;
        if($scopeId!=$storeId){
            $scope = \Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE;
        }
        if($scopeId){
            $active = $scopeConfig->getValue(self::XML_ENABLED, $scope,$scopeId);
            $debug_mod = $scopeConfig->getValue('quivers/parameters/quivers_debug_mode', $scope,$scopeId);
        }
        else{
            $active = $scopeConfig->getValue(self::XML_ENABLED, $scope);
            $debug_mod = $scopeConfig->getValue('quivers/parameters/quivers_debug_mode', $scope);
        }
        if (!$active) {
            return $jsLayout;
        }
            $log = new LogTracking($scopeConfig); 
            if($debug_mod){
                $log->debug_mode_on($debug_mod,
                    'block/LayoutProcessor.php going inside layout print',
                    null, null ,null);
            }

        /* for phone no. validation (shipping address on checkout page) */
        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['shippingAddress']['children']['shipping-address-fieldset']['children']
        )) {

            $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
            ['children']['shippingAddress']['children']['shipping-address-fieldset']['children']
            ['telephone']['config']['validation'] = [
                'validate_quivers_phone_number'=>true,
            ];
        }

        /* for billing address of each of the payment_method */
        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
            ['payment']['children']['payments-list']['children']
        )) {

            foreach ($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                     ['payment']['children']['payments-list']['children'] as $key => $payment) {

                /* telephone validation*/
                if (isset($payment['children']['form-fields']['children']['telephone'])) {

                    $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                    ['payment']['children']['payments-list']['children'][$key]['children']['form-fields']['children']['telephone']['validation'] = [
                            'validate_quivers_phone_number' => true,
                        ];
                }
            }
        }

        /* for billing address on payment page */
        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
            ['payment']['children']['afterMethods']['children']['billing-address-form']
        )) {

            /* telephone validation*/
            if (isset($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                ['payment']['children']['afterMethods']['children']['billing-address-form']['children']['form-fields']
                ['children']['telephone']
            )) {
                $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                ['payment']['children']['afterMethods']['children']['billing-address-form']['children']['form-fields']['children']['telephone']['validation'] = [
                    'validate_quivers_phone_number' => true,
                ];
            }
        }
        return $jsLayout;
    }
}
