<?php

namespace Quivers\Integration\Model\Config\Source;

use Magento\Payment\Model\Method\AbstractMethod;
use Quivers\Integration\LogTracking;

class EnableStripe implements \Magento\Framework\Option\ArrayInterface
{
    const XML_QUIVERS_ACTIVE = 'quivers/parameters/active';
    protected $scopeConfig;

	public function __construct(
		\Magento\Framework\HTTP\Client\Curl $curl,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\App\Request\Http $request
	) {
        $this->scopeConfig = $scopeConfig;
        $this->request = $request;
	}

    public function toOptionArray()
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $scope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $storeId = $storeManager->getStore()->getStoreId();
        $websiteId = $storeManager->getWebsite()->getWebsiteId();        
        $log = new LogTracking($this->scopeConfig);
        $quiversactive = 0;
        $scopeId = $storeId ? $storeId : $websiteId;
        if($scopeId!=$storeId){
            $scope = \Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE;
        }
        if($scopeId){
            $quiversactive = $this->scopeConfig->getValue(self::XML_QUIVERS_ACTIVE, $scope,$scopeId);
            $debug_mod = $this->scopeConfig->getValue('quivers/parameters/quivers_debug_mode', $scope,$scopeId);
        }else{
            $quiversactive = $this->scopeConfig->getValue(self::XML_QUIVERS_ACTIVE, $scope);
            $debug_mod = $this->scopeConfig->getValue('quivers/parameters/quivers_debug_mode', $scope);
        }
        
		if($debug_mod){
            $log->debug_mode_on(
				$debug_mod,'WebsiteId - '.$websiteId.' And QuiversActive - '.$quiversactive,
				null,null,null); 
        }
        if($quiversactive){
        return[
            [
                'value' => 1,
                'label' => __('Yes')
            ],[
                    'value' => 1,
                    'label' => __('No')
            ]
            ];
        }else{
            return
            [
                [
                    'value' => 0,
                    'label' => __('No')
                ],[
                        'value' => 0,
                        'label' => __('Yes')
                ]
                ];
        }
        
    }
}
